=== debian/changelog ===
pd-list-abs (0.1-6) unstable; urgency=medium

  * Modernize 'licensecheck' target
    + Ensure that 'licensecheck' is run with the C.UTF-8 locale
    + Exclude debian/ from 'licensecheck'
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 07 Dec 2022 10:46:41 +0100

pd-list-abs (0.1-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Archive, Bug-Database.

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Modernize 'licensecheck' target
    + Re-generated d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 05 Dec 2022 10:50:55 +0100

pd-list-abs (0.1-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Removed Hans-Christoph Steiner from Uploaders as he requested
  * Add salsa-ci configuration
  * Remove obsolete file d/source/local-options
  * Declare that building this package does not require 'root' powers.
  * Apply "warp-and-sort -ast"
  * Bump dh-compat to 13
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 04 Sep 2022 13:50:08 +0200

pd-list-abs (0.1-3) unstable; urgency=medium

  * Simplified & unified d/rules
    * Enabled hardening
    * Bumped dh compat to 11
  * Updated Vcs-* stanzas to salsa.d.o
  * Updated maintainer address
  * Switched URLs to https://
  * Removed trailing whitespace in debian/*
  * Updated d/copyright_hints
  * Bumped standards version to 4.1.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 01 Feb 2018 23:18:50 +0100

pd-list-abs (0.1-2) unstable; urgency=medium

  [ Hans-Christoph Steiner ]
  * Added DM-Upload-Allowed: yes since I'm now a DM
  * Bumped standards version to 3.9.2
  * Ignore .pc since this uses 3.0 (quilt) format
  * Added pkg-multimedia suggested options to get patches to unapply
  * Added Vcs-* lines
  * Depends: puredata-core | pd, so the depends is not only on a virtual package
  * Removed leading article from synopsis
  * Bumped Standards-Version to 3.9.3
  * Updated to copyright-format/1.0
  * Removed 'DM-Upload-Allowed: yes', its deprecated

  [ IOhannes m zmölnig ]
  * Specified which files are covered by upstream license
  * Removed Debian-specific .gitignore file
  * Degraded pd-libdir to "Recommends"
  * d/copyright: added copyright-holders for debian/
  * Added myself to uploaders.
  * Updated Vcs-* stanzas to canonical https:// URLs
  * Bumped standards to 3.9.8

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 10 Jun 2016 21:02:35 +0200

pd-list-abs (0.1-1) unstable; urgency=low

  * Initial release (Closes: #591834)

 -- Hans-Christoph Steiner <hans@eds.org>  Tue, 15 Feb 2011 15:10:52 -0500
