=== debian/control ===
Source: pd-list-abs
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://puredata.info
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-list-abs.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-list-abs

Package: pd-list-abs
Architecture: all
Depends:
 puredata-core | pd,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 pd-libdir,
Description: library of list operations for Pd
 list-abs is a Pd library of all sorts of operations for lists of data,
 ranging from mathematics, sorting, ranging, etc.  All of the objects are
 implemented using Pd, and for the most part only using objects included in
 Pd-vanilla.
