=== debian/watch ===
version=3
https://sf.net/pure-data/list-abs-(.*)\.tar\.gz
